#ifndef _GREYSCALE8IMAGE_H_
#define _GREYSCALE8IMAGE_H_

#include "Image.h"

/**
   This is a 8 BPP grey scale image class for use with the data_flow system
*/

class GreyScale8Image : public Image {

 private:
  

   inline unsigned char get_byte (int &x, int &y, unsigned char* buf, int &w, int &h) {
     return buf[(h - y - 1) * w + x];
   }

   inline void set_byte (int &x, int &y,unsigned char &val, unsigned char* buf, int &w, int &h) {
     buf[(h - y - 1) * w + x] = val;
   }

   void create(int width, int height);

   void destroy();

 public:

   inline unsigned char get_val (int x, int y) {return get_byte(x,y,m_data, m_width, m_height);}
   inline void  set_val (int x, int y, unsigned char val) {set_byte(x,y,val,m_data,m_width,m_height);}

   GreyScale8Image();

   GreyScale8Image(int width, int height);

   GreyScale8Image(int width, int height, const unsigned char val);

   GreyScale8Image(const GreyScale8Image &image);

   GreyScale8Image(int width, int height, unsigned char *buffer);

   virtual bool write_ppm (string &filename);

   virtual bool read_ppm (string &filename);

   virtual void draw_rect(CRect &rect, unsigned char val = 255);

   void initialize (const unsigned char val);

   virtual ~GreyScale8Image();

   void resize (int width, int height);
};

#endif
