// Image.h: interface for the Image class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _IMAGE_H__
#define _IMAGE_H__

#include "Object.h"
#include "CRect.h"

#define GREYSCALE 0
#define RGB_16 1 // X RRRRR GGGGG BBBBB (2 bytes)
#define RGB_24 2 // 0xRR 0xGG 0xBB 0x00 (4 bytes)


class Image : public Object 
{
 public:
  Image(int type);	
  virtual ~Image();
  int get_width () { return m_width;}
  int get_height() { return m_height;}
  unsigned char* get_data() {return m_data;}
  virtual bool write_ppm (string &filename)= 0;
  virtual bool read_ppm (string &filename) = 0;
  virtual void draw_rect(CRect &rect, unsigned char val) = 0;

  int pixel_byte_length () {
    switch(m_type) {
    case GREYSCALE:
      return 1;
      break;
    case RGB_24:
      return 4;
      break;
    case RGB_16:
      return 2;
      break;
    }
  }
  
 protected:
  int m_width;
  int m_height;
  unsigned char *m_data;
  int m_type;
  
  
 private:
  Image();
  
};

#endif 
