// Copyright (C) 2000 Dominic Letourneau (doumdi@yahoo.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef _KERNEL_H_
#define _KERNEL_H_

#include "Object.h"
#include "Node.h"

/**
   The kernel class contains a integer verter.
*/
class Kernel : public Object {
 public:
  Kernel(int size)
    : m_size(size) {
    m_data = new int[size * size];
  } 
  virtual ~Kernel() {
    if (m_data) delete m_data;
  }			
  int *get_data() {return m_data;}
  int get_size() {return m_size;}
  
 private:
  
  int *m_data;
  int m_size;
};


class KernelConst : public Node
{
public:
		
  KernelConst(string nodeName, ParameterSet params);
  
  virtual ~KernelConst();
  
  virtual ObjectRef getOutput(int output_id, int count); 

private:

  ObjectRef m_output;	
  ObjectRef m_size;
  ObjectRef m_values;

  // Default constructor, should not be used
  KernelConst() {throw(GeneralException("KernelConst default constructor should not be called",__FILE__,__LINE__));}

};


#endif
