// Copyright (C) 2000 Dominic Letourneau (doumdi@yahoo.com)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this file.  If not, write to the Free Software Foundation,
// 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef _PPMREADER_H_
#define _PPMREADER_H_

#include "Node.h"
#include "Exception.h"
#include "RGB24Image.h"
/** 
    Reads a PPM file and stores the data into a RGB24Image 
    @author Dominic Letourneau
    @version 1.0
 */
class PPMReader : public Node {

public:

   ///Constructor, takes the name of the node and a set of parameters
   PPMReader(string nodeName, ParameterSet params);

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 



protected:

   ObjectRef output;

   ///Default constructor, should not be used
   PPMReader() {throw(GeneralException("PPMReader default constructor should not be called",__FILE__,__LINE__));}

 private:
   int m_filenameID;
};
#endif

